#include <linux/miscdevice.h>
#include <linux/delay.h>
#include <asm/irq.h>
#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/init.h>
#include <linux/mm.h>
#include <linux/fs.h>
#include <linux/types.h>
#include <linux/delay.h>
#include <linux/moduleparam.h>
#include <linux/slab.h>
#include <linux/errno.h>
#include <linux/ioctl.h>
#include <linux/cdev.h>
#include <linux/string.h>
#include <linux/list.h>
#include <linux/pci.h>
#include <linux/ioport.h>
#include <linux/gpio.h>
#include <asm/uaccess.h>
#include <asm/atomic.h>
#include <asm/unistd.h>
#include <asm/io.h>
#include <asm/system.h>
#include <asm/uaccess.h>


#define MEMDEV_MAJOR 255
#define MEMDEV_NR_DEVS 2 
//#define MEMDEV_SIZE 4096

static mem_major = MEMDEV_MAJOR;
struct cdev cdev; 
static dev_t devno;
static struct class *myclass;

void led_turn_off(void) 
{
        
	gpio_direction_output(7,0); 
	
  	printk("led turn off\n");
}

void led_turn_on(void)
{       
	
	
        gpio_direction_output(7,1); 
        
	
  printk("led turn on\n");
	}


static int leds_ioctl(
        
        struct file *file,
        unsigned int cmd,
        unsigned long arg)
{
 switch(cmd) 
 {
        case 0: led_turn_off();
                break;
        case 1: led_turn_on();
                break;
                
        default:
                return -EINVAL;
        }
}


static struct file_operations dev_fops = {
        .owner  =  THIS_MODULE,
        .unlocked_ioctl = leds_ioctl,
        
};


static int __init dev_init(void)
{
	int ret;
	
	gpio_free(7);
        ret = gpio_request(7, "gpio");     
        int result;

      dev_t devno = MKDEV(mem_major, 0);

    result = register_chrdev_region(devno, 2, "gpio");
 
  if (result < 0)
    return result;


  cdev_init(&cdev, &dev_fops);
  cdev.owner = THIS_MODULE;
  cdev.ops = &dev_fops;
   cdev_add(&cdev, MKDEV(mem_major, 0), MEMDEV_NR_DEVS);
        
  myclass = class_create(THIS_MODULE, "myclass");
  device_create(myclass, NULL,devno, NULL,"gpio");

  fail_malloc: 
  unregister_chrdev_region(devno, 1);

  return result;
      
}

static void __exit dev_exit(void)
{
  gpio_free(7);
               
  cdev_del(&cdev);   /*ע豸*/
 
  unregister_chrdev_region(MKDEV(mem_major, 0), 2); /*ͷ豸*/
  device_destroy(myclass,devno);
  class_destroy(myclass);
}

module_init(dev_init);
module_exit(dev_exit);

MODULE_LICENSE("GPL");
MODULE_AUTHOR("FriendlyARM Inc.");
